<?php
/**
 *
 * @package jvbPlugin
 * @version $Id: jvb_auth.php, v 1.0 2008/08/18 15:37:17 koudanshi Exp $
 * @copyright (c) 2003-2008 BBPixel
 *
 * Minimum Requirement: PHP 4.3.3 | MySQL 4.1
 */


// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport('joomla.event.plugin');


class plgAuthenticationJvb_auth extends JPlugin
{


	function plgAuthenticationJvb_auth(& $subject, $config) {
		parent::__construct($subject, $config);
	}



	function onAuthenticate( $credentials, $options, &$response )
	{
		global $mainframe;

		//You are an admin? Using Joomla login control!
		if ( !strpos(JPATH_BASE, 'administrator') === false or $mainframe->getCfg('offline' ) == 1 ){

			jimport('joomla.user.helper');

			// Joomla does not like blank passwords
			if (empty($credentials['password']))
			{
				$response->status = JAUTHENTICATE_STATUS_FAILURE;
				$response->error_message = 'Введите пароль';
				return false;
			}

			// Initialize variables
			$conditions = '';

			// Get a database object
			$db =& JFactory::getDBO();

			$query = 'SELECT `id`, `password`, `gid`'
				. ' FROM `#__users`'
				. ' WHERE username=' . $db->Quote( $credentials['username'] )
				;
			$db->setQuery( $query );
			$result = $db->loadObject();


			if($result)
			{
				$parts	= explode( ':', $result->password );
				$crypt	= $parts[0];
				$salt	= @$parts[1];
				$testcrypt = JUserHelper::getCryptedPassword($credentials['password'], $salt);

				if ($crypt == $testcrypt) {
					$user = JUser::getInstance($result->id); // Bring this in line with the rest of the system
					$response->email = $user->email;
					$response->fullname = $user->name;
					$response->status = JAUTHENTICATE_STATUS_SUCCESS;
					$response->error_message = '';
				} else {
					$response->status = JAUTHENTICATE_STATUS_FAILURE;
					$response->error_message = 'Неправильный пароль';
				}
			}
			else
			{
				$response->status = JAUTHENTICATE_STATUS_FAILURE;
				$response->error_message = 'Пользователя не существует';
			}
		}
		else {
			//Login using forum control
			global $jvbpixel;

			$response->status = JAUTHENTICATE_STATUS_FAILURE;
			$response->error_message = 'Ошибка BBpixel аутентификации';

			if ( !empty($jvbpixel->_userinfo['userid']) ) {
				$response->status = JAUTHENTICATE_STATUS_SUCCESS;
				$response->error_message = '';
				$response->email 	= $credentials['email'];
				$response->fullname = $credentials['name'];
			}

		}
	}
}
?>
